Xapian: API Documentation: Xapian::Weight Class Reference

xapian-core 1.4.30

Public Types | Public Member Functions | Protected Types | Protected Member Functions | List of all members
Xapian::Weight Class Referenceabstract

Abstract base class for weighting schemes. More...

`#include <weight.h>`

Inheritance diagram for Xapian::Weight:
[legend]

## Public Types
enum | type_smoothing { TWO_STAGE_SMOOTHING = 1 , DIRICHLET_SMOOTHING = 2 , ABSOLUTE_DISCOUNT_SMOOTHING = 3 , JELINEK_MERCER_SMOOTHING = 4 , DIRICHLET_PLUS_SMOOTHING = 5 }
| Type of smoothing to use with the Language Model Weighting scheme. More...

## Public Member Functions
| Weight ()
| Default constructor, needed by subclass constructors.
virtual | ~Weight ()
| Virtual destructor, because we have virtual methods.
virtual Weight * | clone () const =0
| Clone this object.
virtual std::string | name () const
| Return the name of this weighting scheme.
virtual std::string | serialise () const
| Return this object's parameters serialised as a single string.
virtual Weight * | unserialise (const std::string &serialised) const
| Unserialise parameters.
virtual double | get_sumpart (Xapian::termcount wdf, Xapian::termcount doclen, Xapian::termcount uniqterms) const =0
| Calculate the weight contribution for this object's term to a document.
virtual double | get_maxpart () const =0
| Return an upper bound on what get_sumpart() can return for any document.
virtual double | get_sumextra (Xapian::termcount doclen, Xapian::termcount uniqterms) const =0
| Calculate the term-independent weight component for a document.
virtual double | get_maxextra () const =0
| Return an upper bound on what get_sumextra() can return for any document.

## Protected Types
enum | stat_flags { COLLECTION_SIZE = 1 , RSET_SIZE = 2 , AVERAGE_LENGTH = 4 , TERMFREQ = 8 , RELTERMFREQ = 16 , QUERY_LENGTH = 32 , WQF = 64 , WDF = 128 , DOC_LENGTH = 256 , DOC_LENGTH_MIN = 512 , DOC_LENGTH_MAX = 1024 , WDF_MAX = 2048 , COLLECTION_FREQ = 4096 , UNIQUE_TERMS = 8192 , TOTAL_LENGTH = COLLECTION_SIZE | AVERAGE_LENGTH }
| Stats which the weighting scheme can use (see need_stat()). More...

## Protected Member Functions
void | need_stat (stat_flags flag)
| Tell Xapian that your subclass will want a particular statistic.
virtual void | init (double factor)=0
| Allow the subclass to perform any initialisation it needs to.
| Weight (const Weight &)
| Don't allow copying.
Xapian::doccount | get_collection_size () const
| The number of documents in the collection.
Xapian::doccount | get_rset_size () const
| The number of documents marked as relevant.
Xapian::doclength | get_average_length () const
| The average length of a document in the collection.
Xapian::doccount | get_termfreq () const
| The number of documents which this term indexes.
Xapian::doccount | get_reltermfreq () const
| The number of relevant documents which this term indexes.
Xapian::termcount | get_collection_freq () const
| The collection frequency of the term.
Xapian::termcount | get_query_length () const
| The length of the query.
Xapian::termcount | get_wqf () const
| The within-query-frequency of this term.
Xapian::termcount | get_doclength_upper_bound () const
| An upper bound on the maximum length of any document in the shard.
Xapian::termcount | get_doclength_lower_bound () const
| A lower bound on the minimum length of any document in the shard.
Xapian::termcount | get_wdf_upper_bound () const
| An upper bound on the wdf of this term in the shard.
Xapian::totallength | get_total_length () const
| Total length of all documents in the collection.

## Detailed Description

Abstract base class for weighting schemes.

## Member Enumeration Documentation

## ◆ stat_flags

enum Xapian::Weight::stat_flags
| protected

Stats which the weighting scheme can use (see need_stat()).

Enumerator
COLLECTION_SIZE | Number of documents in the collection.
RSET_SIZE | Number of documents in the RSet.
AVERAGE_LENGTH | Average length of documents in the collection.
TERMFREQ | How many documents the current term is in.
RELTERMFREQ | How many documents in the RSet the current term is in.
QUERY_LENGTH | Sum of wqf for terms in the query.
WQF | Within-query-frequency of the current term.
WDF | Within-document-frequency of the current term in the current document.
DOC_LENGTH | Length of the current document (sum wdf).
DOC_LENGTH_MIN | Lower bound on (non-zero) document lengths. This bound is for the current shard and is suitable for using to calculate upper bounds to return from get_maxpart() and get_maxextra().
DOC_LENGTH_MAX | Upper bound on document lengths. This bound is for the current shard and is suitable for using to calculate upper bounds to return from get_maxpart() and get_maxextra().
WDF_MAX | Upper bound on wdf. This bound is for the current shard and is suitable for using to calculate upper bounds to return from get_maxpart() and get_maxextra().
COLLECTION_FREQ | Sum of wdf over the whole collection for the current term.
UNIQUE_TERMS | Number of unique terms in the current document.
TOTAL_LENGTH | Sum of lengths of all documents in the collection. This gives the total number of term occurrences.

## ◆ type_smoothing

enum Xapian::Weight::type_smoothing

Type of smoothing to use with the Language Model Weighting scheme.

Default is TWO_STAGE_SMOOTHING.

## Constructor & Destructor Documentation

## ◆ Weight()

Xapian::Weight::Weight | ( | const Weight & |  | ) |
| protected

Don't allow copying.

This would ideally be private, but that causes a compilation error with GCC 4.1 (which appears to be a bug).

## Member Function Documentation

## ◆ clone()

virtual Weight * Xapian::Weight::clone | ( |  | ) | const
| pure virtual

Clone this object.

This method allocates and returns a copy of the object it is called on.

If your subclass is called FooWeight and has parameters a and b, then you would implement FooWeight::clone() like so:

FooWeight * FooWeight::clone() const { return new FooWeight(a, b); }

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Implemented in Xapian::CoordWeight.

## ◆ get_doclength_lower_bound()

Xapian::termcount Xapian::Weight::get_doclength_lower_bound | ( |  | ) | const
| inlineprotected

A lower bound on the minimum length of any document in the shard.

This bound does not include any zero-length documents.

This should only be used by get_maxpart() and get_maxextra().

## ◆ get_doclength_upper_bound()

Xapian::termcount Xapian::Weight::get_doclength_upper_bound | ( |  | ) | const
| inlineprotected

An upper bound on the maximum length of any document in the shard.

This should only be used by get_maxpart() and get_maxextra().

## ◆ get_maxextra()

virtual double Xapian::Weight::get_maxextra | ( |  | ) | const
| pure virtual

Return an upper bound on what get_sumextra() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

## ◆ get_maxpart()

virtual double Xapian::Weight::get_maxpart | ( |  | ) | const
| pure virtual

Return an upper bound on what get_sumpart() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

## ◆ get_sumextra()

virtual double Xapian::Weight::get_sumextra | ( | Xapian::termcount | doclen,
|  | Xapian::termcount | uniqterms
| ) |  | const
| pure virtual

Calculate the term-independent weight component for a document.

The parameter gives information about the document which may be used in the calculations:

Parameters

  doclen | The document's length (unnormalised).
  uniqterms | The number of unique terms in the document.

Implemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

## ◆ get_sumpart()

virtual double Xapian::Weight::get_sumpart | ( | Xapian::termcount | wdf,
|  | Xapian::termcount | doclen,
|  | Xapian::termcount | uniqterms
| ) |  | const
| pure virtual

Calculate the weight contribution for this object's term to a document.

The parameters give information about the document which may be used in the calculations:

Parameters

  wdf | The within document frequency of the term in the document.
  doclen | The document's length (unnormalised).
  uniqterms | Number of unique terms in the document (used for absolute smoothing).

Implemented in Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::IfB2Weight, Xapian::LMWeight, Xapian::CoordWeight, Xapian::BoolWeight, Xapian::InL2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, and Xapian::TradWeight.

## ◆ get_wdf_upper_bound()

Xapian::termcount Xapian::Weight::get_wdf_upper_bound | ( |  | ) | const
| inlineprotected

An upper bound on the wdf of this term in the shard.

This should only be used by get_maxpart() and get_maxextra().

## ◆ init()

virtual void Xapian::Weight::init | ( | double | factor | ) |
| protectedpure virtual

Allow the subclass to perform any initialisation it needs to.

Parameters

  factor | Any scaling factor (e.g. from OP_SCALE_WEIGHT). If the Weight object is for the term-independent weight supplied by get_sumextra()/get_maxextra(), then init(0.0) is called (starting from Xapian 1.2.11 and 1.3.1 - earlier versions failed to call init() for such Weight objects).

Implemented in Xapian::CoordWeight.

## ◆ name()

virtual std::string Xapian::Weight::name | ( |  | ) | const
| virtual

Return the name of this weighting scheme.

This name is used by the remote backend. It is passed along with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called FooWeight, return "FooWeight" from this method (Xapian::BM25Weight returns "Xapian::BM25Weight" here).

If you don't want to support the remote backend, you can use the default implementation which simply returns an empty string.

Reimplemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

## ◆ need_stat()

void Xapian::Weight::need_stat | ( | stat_flags | flag | ) |
| inlineprotected

Tell Xapian that your subclass will want a particular statistic.

Some of the statistics can be costly to fetch or calculate, so Xapian needs to know which are actually going to be used. You should call need_stat() from your constructor for each such statistic.

Parameters

  flag | The stat_flags value for a required statistic.

## ◆ serialise()

virtual std::string Xapian::Weight::serialise | ( |  | ) | const
| virtual

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

## ◆ unserialise()

virtual Weight * Xapian::Weight::unserialise | ( | const std::string & | serialised | ) | const
| virtual

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Parameters

  serialised | A string containing the serialised parameters.

Reimplemented in Xapian::BoolWeight, Xapian::TfIdfWeight, Xapian::BM25Weight, Xapian::BM25PlusWeight, Xapian::TradWeight, Xapian::InL2Weight, Xapian::IfB2Weight, Xapian::IneB2Weight, Xapian::BB2Weight, Xapian::DLHWeight, Xapian::PL2Weight, Xapian::PL2PlusWeight, Xapian::DPHWeight, Xapian::LMWeight, and Xapian::CoordWeight.

The documentation for this class was generated from the following file:

- xapian/weight.h